align 16
proc_exception_handler:
; in:	RCX	EXCEPTION_POINTERS
; out:	RAX	EXCEPTION_CONTINUE_EXECUTION
;		EXCEPTION_CONTINUE_SEARCH

	push	rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
	sub	rsp,8*(4+1)

	lea	rdi,[tmp_buf]
	cld
	mov	eax,'code'
	stosd
	mov	al,'='
	stosb
	mov	rsi,[rcx+EXCEPTION_POINTERS64.PEXCEPTION_RECORD]
	mov	eax,[rsi+EXCEPTION_RECORD64.ExceptionCode]
	call	hexa_32_eax

	lea	rdi,[rdi+8]
	mov	al,0Dh
	stosb
	mov	al,0Ah
	stosb

	mov	eax,'addr'
	stosd
	mov	al,'='
	stosb
	mov	rax,[rsi+EXCEPTION_RECORD64.ExceptionAddress]
	call	hexa_64_rax

	mov	rax,[rcx+EXCEPTION_POINTERS64.PCONTEXT]
	xor	ebx,ebx
	lea	rsi,[rax+CONTEXT64.Rax]

fdbg_e_L0:
	lea	rdi,[rdi+16]
	mov	al,0Dh
	stosb
	mov	al,0Ah
	stosb
	lea	rdx,[GPR_alphabetical_0_terminated]
	mov	eax,dword [rdx+rbx*4]
	stosd
	mov	byte [rdi-1],'='
	lea	rax,[gpr_transform]
	movzx	edx,byte [rax+rbx*1]
	mov	rax,qword [rsi+rdx*8]
	call	hexa_64_rax
	inc	ebx
	cmp	ebx,16
	jc	fdbg_e_L0

	mov	byte [rdi+16],0

	xor	r9,r9
	lea	r8,[e_title]
	lea	rdx,[tmp_buf]
	xor	ecx,ecx
	call	qword [MessageBoxA]

	xor	ecx,ecx
	call	qword [ExitProcess]	; no, Vista replaces ExitProcess with ntdll.RtlExitUserProcess


	add	rsp,8*(4+1)
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx

; To return control to the point at which the exception occurred, return EXCEPTION_CONTINUE_EXECUTION (0xffffffff). To continue the handler search, return EXCEPTION_CONTINUE_SEARCH (0x0).
if EXCEPTION_CONTINUE_SEARCH=0
	xor	eax,eax
else
	mov	rax,EXCEPTION_CONTINUE_SEARCH
end if

;if EXCEPTION_CONTINUE_EXECUTION=-1
;	or	rax,-1				; has less opcode size and gives the same result as mov rax,...
;						; if you don't worry about destroing flags register
;else
;	mov	rax,EXCEPTION_CONTINUE_EXECUTION
;end if

	ret
